Wt: Wt::WLength Class Reference

Wt 3.3.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Attributes
Wt::WLength Class Reference

A value class that describes a CSS length. More...

`#include <Wt/WLength>`

List of all members.

## Public Types
enum | Unit { FontEm, FontEx, Pixel, Inch, Centimeter, Millimeter, Point, Pica, Percentage }
| The unit. More...
## Public Member Functions
| WLength ()
| Creates an 'auto' length.
| WLength (const char *c)
| Creates a length by parsing the argument as a css length string.
| WLength (double value, Unit unit=Pixel)
| Creates a length with value and unit.
| WLength (int value, Unit unit=Pixel)
| Creates a length with value and unit.
| WLength (long value, Unit unit=Pixel)
| Creates a length with value and unit.
| WLength (unsigned value, Unit unit=Pixel)
| Creates a length with value and unit.
| WLength (unsigned long value, Unit unit=Pixel)
| Creates a length with value and unit.
bool | isAuto () const
| Returns whether the length is 'auto'.
double | value () const
| Returns the value.
Unit | unit () const
| Returns the unit.
const std::string | cssText () const
| Returns the CSS text.
bool | operator== (const WLength &other) const
| Comparison operator.
bool | operator!= (const WLength &other) const
| Comparison operator.
double | toPixels (double fontSize=16.0) const
| Returns the (approximate) length in pixels.
## Static Public Attributes
static WLength | Auto
| An 'auto' length.

## Detailed Description

A value class that describes a CSS length.

The class combines a value with a unit. There is a special value auto which has a different meaning depending on the context.

## Member Enumeration Documentation

enum Wt::WLength::Unit

The unit.

Enumerator:

  FontEm | The relative font size.
  FontEx | The height of an 'x' in the font.
  Pixel | Pixel, relative to canvas resolution.
  Inch | Inche.
  Centimeter | Centimeter.
  Millimeter | Millimeter.
  Point | Point (1/72 Inch)
  Pica | Pica (12 Point)
  Percentage | Percentage (meaning context-sensitive)

## Constructor & Destructor Documentation

Wt::WLength::WLength | ( |  | ) |

Creates an 'auto' length.

Specifies an 'auto' length.

See also:
  Auto

Wt::WLength::WLength | ( | const char * | c | ) |

Creates a length by parsing the argument as a css length string.

This supports all CSS length formats that have an API counterpart.

Wt::WLength::WLength | ( | double | value,
|  | Unit | unit = `Pixel`
| ) |  |

Creates a length with value and unit.

This constructor is also used for the implicit conversion of a double to a WLength, assuming a pixel unit.

Wt::WLength::WLength | ( | int | value,
|  | Unit | unit = `Pixel`
| ) |  |

Creates a length with value and unit.

This constructor is also used for the implicit conversion of a int to a WLength, assuming a pixel unit.

Wt::WLength::WLength | ( | long | value,
|  | Unit | unit = `Pixel`
| ) |  |

Creates a length with value and unit.

This constructor is also used for the implicit conversion of a long to a WLength, assuming a pixel unit.

Wt::WLength::WLength | ( | unsigned | value,
|  | Unit | unit = `Pixel`
| ) |  |

Creates a length with value and unit.

This constructor is also used for the implicit conversion of an unsigned to a WLength, assuming a pixel unit.

Wt::WLength::WLength | ( | unsigned long | value,
|  | Unit | unit = `Pixel`
| ) |  |

Creates a length with value and unit.

This constructor is also used for the implicit conversion of an unsigned long to a WLength, assuming a pixel unit.

## Member Function Documentation

bool Wt::WLength::isAuto | ( |  | ) | const

Returns whether the length is 'auto'.

See also:
  WLength(), Auto

double Wt::WLength::toPixels | ( | double | fontSize = `16.0` | ) | const

Returns the (approximate) length in pixels.

When the length isAuto(), 0 is returned, otherwise the approximate length in pixels.

Unit Wt::WLength::unit | ( |  | ) | const

Returns the unit.

See also:
  value()

double Wt::WLength::value | ( |  | ) | const

Returns the value.

See also:
  unit()

## Member Data Documentation

WLength Wt::WLength::Auto`[static]`

An 'auto' length.

See also:
  WLength()

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator